from machine import Pin ,PWM, SPI, Timer, ADC#导入Pin模块
import time
import network
from simple import MQTTClient #导入MQTT板块

msg=b""

right_LIGHT = PWM(Pin(1), freq=50, duty=0)

left_LIGHT  = PWM(Pin(2), freq=50, duty=0)

S1 = PWM(Pin(19), freq=50, duty=0)
          

#WIFI连接函数
def WIFI_Connect():

    WIFI_LED=Pin(15, Pin.OUT) #初始化WIFI指示灯

    wlan = network.WLAN(network.STA_IF) #STA模式
    wlan.active(True)                   #激活接口
    start_time=time.time()              #记录时间做超时判断

    if not wlan.isconnected():
        print('connecting to network...')
        wlan.connect('Xiaomi_97F2', '6809328500') #输入WIFI账号密码
        while not wlan.isconnected():
            
            #LED闪烁提示
            WIFI_LED.value(1)
            time.sleep_ms(300)
            WIFI_LED.value(0)
            time.sleep_ms(300)
            

            #超时判断,15秒没连接成功判定为超时
            if time.time()-start_time > 15 :
                print('WIFI Connected Timeout!')
                wlan.active(False) #反激活WiFi
                break

    if wlan.isconnected():
        #LED点亮
        WIFI_LED.value(1)

        #串口打印信息
        print('network information:', wlan.ifconfig())
        
        return True

    else:
        return False

def Servo(servo,angle):
    S1.duty(int(((angle)*2/180+0.5)/20*1023))
    time.sleep(1)
    
'''        
def MQTT_Send():
    msg=input("请输入: ")
    client.publish(TOPIC, msg)
    print(TOPIC,"send:",msg)
'''
    
def deal(MSG):
    command = MSG.decode('utf-8')
    if command !="":
        # 使用'/'作为分隔符分割字符串  
        parts = command.split('/') 
          
        print(parts)  # 输出: ['LED', 'right_LIGHT', '30%'],['MOTOR', 'go', '60%'],['SERVO', 'turn', '30']
        
        try:  
            # 处理最后一个部分，如果它包含'%'  
            if '%' in parts[-1]:  
                # 按照'%'切割最后一个部分，并转换为浮点数  
                percentage_str, _ = parts[-1].split('%')  
                percentage_float = float(percentage_str) / 100  
                # 将最后一个部分替换为转换后的浮点数  
                parts[-1] = str(percentage_float)
        
        
            print(parts)  # 输出: ['motor', 'go', '0.6']
        
            value=float(parts[-1])
            print(value)
            
        except ValueError:  
            print("无法将字符串转换为数字")
        
        if parts[0]=="LED":
            DUTY=int(value*1023)
            if parts[1]=="right_LED":
                right_LIGHT.duty(DUTY)
            if parts[1]=="left_LED":
                left_LIGHT.duty(DUTY)
            if parts[1]=="BOTH":
                right_LIGHT.duty(DUTY)
                left_LIGHT.duty(DUTY)
                
        if parts[0]=="SERVO":
                angle=int(value)
                Servo(S1,angle)
    
#接收数据任务
def MQTT_Rev(TOPIC,msg):
    client.check_msg()   #获得TOPIC和msg
    print(msg)
    deal(msg)
        
#执行WIFI连接函数并判断是否已经连接成功
if WIFI_Connect():

    SERVER = 'broker.emqx.io'# MQTT服务器
    PORT = 1883
    TOPIC = "FUNCTIONCALL_MQTT" # TOPIC名称
    CLIENT_ID = 'C6' # 客户端ID
    
    client = MQTTClient(CLIENT_ID, SERVER, PORT)
    client.set_callback(MQTT_Rev)  #配置回调函数
    client.connect()
    client.subscribe(TOPIC) #订阅主题
    
print("系统开始启动……")

while True:
    MQTT_Rev(TOPIC,msg)
    time.sleep(1)

